/*
	This simple extension of the java.awt.Frame class
	contains all the elements necessary to act as the
	main window of an application.
 */

import java.awt.*;
import java.io.*;

public class SEISCONF extends Dialog
{
    String SEISAN_TOP = "/seismo/";
    String INPUTDEF_DIR = ""; // Directory of *.INP files 
    static boolean LOCAPP=false; // true if it is call from prompt line
	public SEISCONF(Frame parent)
	{
	    super(parent);
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(563,313);
		setVisible(false);
		ExitB.setLabel("EXIT");
		add(ExitB);
		ExitB.setBounds(228,252,120,36);
		button1.setLabel("EDIT");
		add(button1);
		button1.setBounds(24,24,84,36);
		HypFileButt.setLabel("EDIT");
		add(HypFileButt);
		HypFileButt.setBounds(24,96,84,36);
		label1.setText("General SEISAN configuration Parameters (SEISAN.DEF)");
		label1.setAlignment(java.awt.Label.CENTER);
		add(label1);
		label1.setBounds(108,24,432,36);
		label2.setText("Parameters for the hypocenter determination (STATION?.HYP)");
		label2.setAlignment(java.awt.Label.CENTER);
		add(label2);
		label2.setBounds(108,96,432,36);
		button2.setLabel("EDIT");
		add(button2);
		button2.setBounds(24,168,84,36);
		label3.setText(" Parameters for the waveforms plotting tool (MULPLT.DEF)");
		label3.setAlignment(java.awt.Label.CENTER);
		add(label3);
		label3.setBounds(108,168,432,36);
		panel1.setLayout(null);
		add(panel1);
		panel1.setBackground(new java.awt.Color(228,228,228));
		panel1.setBounds(12,12,540,60);
		panel2.setLayout(null);
		add(panel2);
		panel2.setBackground(new java.awt.Color(228,228,228));
		panel2.setBounds(12,84,540,60);
		panel3.setLayout(null);
		add(panel3);
		panel3.setBackground(new java.awt.Color(228,228,228));
		panel3.setBounds(12,156,540,60);
		setTitle("SEISAN CONFIGURATION PARAMETER");
		//}}
		
		//{{INIT_MENUS
		//}}
		
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		ExitB.addActionListener(lSymAction);
		HypFileButt.addActionListener(lSymAction);
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		//}}
		String cad = System.getProperty("SEISAN_TOP");    
		if ((cad!=null) && (cad.trim().length()>0)) {
		    SEISAN_TOP=cad;
		    int i = SEISAN_TOP.length() -1;
		    if ( (i>=0) && (SEISAN_TOP.charAt(i)!='\\') && (SEISAN_TOP.charAt(i)!='/') )
	          SEISAN_TOP = SEISAN_TOP + "/";  
		}    
		else {
		    OKDialog.createOKDialog("SEISAN_TOP is not defined in the enviroment. Using SEISAN_TOP="+SEISAN_TOP);    
		}   
		cad = getInputDefDir();
		if ((cad!=null) && (cad.trim().length()>0)) {
		    INPUTDEF_DIR=cad;
		    int i = INPUTDEF_DIR.length() -1;
		    if ( (INPUTDEF_DIR.charAt(i)!='\\') && (INPUTDEF_DIR.charAt(i)!='/') )
	          INPUTDEF_DIR = INPUTDEF_DIR + "/";  
		}    
		else 
		    OKDialog.createOKDialog("Missing SEISANDEF.INP. You must have this file where JSEISAN java classes are");
		setModal(true);    
	}
		
	
    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}	
		super.setVisible(b);
	}
	
	static public void main(String args[])
	{
	    LOCAPP=true;
		try
		{
			//Create a new instance of our application's frame, and make it visible.
    		(new SEISCONF(new Frame())).show();
		}
		catch (Throwable t)
		{
			System.err.println(t);
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
	}
	
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();
		
		super.addNotify();
	
		if (fComponentsAdjusted)
			return;
	
		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}
	
	// Used for addNotify check.
	boolean fComponentsAdjusted = false;
	
	//{{DECLARE_CONTROLS
	java.awt.Button ExitB = new java.awt.Button();
	java.awt.Button button1 = new java.awt.Button();
	java.awt.Button HypFileButt = new java.awt.Button();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Button button2 = new java.awt.Button();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Panel panel1 = new java.awt.Panel();
	java.awt.Panel panel2 = new java.awt.Panel();
	java.awt.Panel panel3 = new java.awt.Panel();
	//}}
	
	//{{DECLARE_MENUS
	//}}
	
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == SEISCONF.this)
				SEISCONF_WindowClosing(event);
		}
	}
	
	void SEISCONF_WindowClosing(java.awt.event.WindowEvent event)
	{
		// set LOCAPP true for release JSEISAN
		LOCAPP=true;
	}

	
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == ExitB)
				ExitB_ActionPerformed(event);
			else if (object == HypFileButt)
				HypFileButt_ActionPerformed(event);
			else if (object == button1)
				button1_ActionPerformed(event);
			else if (object == button2)
				button2_ActionPerformed(event);
			
			
			
		}
	}


	void ExitB_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// Ended the program
		if(LOCAPP)
		 System.exit(0);
		else 
		 setVisible(false);
			 
	}

	void HypFileButt_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// Show a Dialog for configurate STATION0.HYP
	  HypDialog HypDlg;	
	  File file = new File("STATION0.HYP");
	  QuestionD QDialog= new QuestionD(new Frame(),"A local STATION0.HYP was found. Do you want to configure it ?", true);
	  if (file.exists() ) {
	   QDialog.show();
	  }
	  if (QDialog.OKOUT)
		HypDlg = new HypDialog(new Frame(), true, "./", INPUTDEF_DIR);
	  else	
	    HypDlg = new HypDialog(new Frame(), true, SEISAN_TOP + "DAT/", INPUTDEF_DIR);
	  HypDlg.show();
	  HypDlg.dispose();
	}

	void button1_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// Show a Dialog for configuring SEISAN.DEF
	  DialogPar ParDlg;	
	  File file = new File("SEISAN.DEF");
	  QuestionD QDialog= new QuestionD(new Frame(),"A local SEISAN.DEF was found. Do you want to configure it ?", true);
	  if (file.exists() ) {
	   QDialog.show();
	  }
	  if (QDialog.OKOUT)
		ParDlg = new DialogPar(new Frame(), true,"General Configuration Parameters: SEISAN.DEF", INPUTDEF_DIR + "SEISANDEF.INP",
		                        "SEISAN.DEF");
	  else	                        
	    ParDlg = new DialogPar(new Frame(), true,"General Configuration Parameters: SEISAN.DEF", INPUTDEF_DIR + "SEISANDEF.INP",
		                        SEISAN_TOP + "DAT/SEISAN.DEF");
		ParDlg.show();
		ParDlg.dispose();
	}

	void button2_ActionPerformed(java.awt.event.ActionEvent event)
	{
	  // Show a Dialog for configuring MULPLT.DEF
	  DialogPar ParDlg;	
	  File file = new File("MULPLT.DEF");
	  QuestionD QDialog= new QuestionD(new Frame(),"A local MULPLT.DEF was found. Do you want to configure it ?", true);
	  if (file.exists() ) {
	   QDialog.show();
	  }
	  if (QDialog.OKOUT)
		ParDlg = new DialogPar(new Frame(), true,"Parameters for the waveforms plotting tool: MULPLT.DEF", INPUTDEF_DIR + "MULPLTDEF.INP",
		                        "MULPLT.DEF");
	  else
	   ParDlg = new DialogPar(new Frame(), true,"Parameters for the waveforms plotting tool: MULPLT.DEF", INPUTDEF_DIR + "MULPLTDEF.INP",
		                        SEISAN_TOP + "DAT/MULPLT.DEF");
		ParDlg.show();
		ParDlg.dispose();		 
	}
	
	String getInputDefDir() {
	    return (SEISAN_TOP+"DAT");
	}    
}

